Bullet Collision Detection & Physics Library: gim_array< T > Class Template Reference

Bullet Collision Detection & Physics Library

List of all members
gim_array< T > Class Template Reference

Very simple array container with fast access and simd memory. More...

`#include <gim_array.h>`

## Public Member Functions
void | destroyData ()
bool | resizeData (GUINT newsize)
bool | growingCheck ()
bool | reserve (GUINT size)
void | clear_range (GUINT start_range)
void | clear ()
void | clear_memory ()
| gim_array ()
| gim_array (GUINT reservesize)
| ~gim_array ()
GUINT | size () const
GUINT | max_size () const
T & | operator[] (size_t i)
const T & | operator[] (size_t i) const
T * | pointer ()
const T * | pointer () const
T * | get_pointer_at (GUINT i)
const T * | get_pointer_at (GUINT i) const
T & | at (GUINT i)
const T & | at (GUINT i) const
T & | front ()
const T & | front () const
T & | back ()
const T & | back () const
void | swap (GUINT i, GUINT j)
void | push_back (const T &obj)
void | push_back_mem ()
| Simply increase the m_size, doesn't call the new element constructor.
void | push_back_memcpy (const T &obj)
void | pop_back ()
void | pop_back_mem ()
| Simply decrease the m_size, doesn't call the deleted element destructor.
void | erase (GUINT index)
| fast erase
void | erase_sorted_mem (GUINT index)
void | erase_sorted (GUINT index)
void | insert_mem (GUINT index)
void | insert (const T &obj, GUINT index)
void | resize (GUINT size, bool call_constructor=true, const T &fillData=T())
void | refit ()

## Public Attributes
T * | m_data
GUINT | m_size
GUINT | m_allocated_size

## Detailed Description

template<typename T>
class gim_array< T >

Very simple array container with fast access and simd memory.

Definition at line 42 of file gim_array.h.

## Constructor & Destructor Documentation

## ◆ gim_array() [1/2]

template<typename T>

gim_array< T >::gim_array | ( |  | ) |
| inline

Definition at line 122 of file gim_array.h.

## ◆ gim_array() [2/2]

template<typename T>

gim_array< T >::gim_array | ( | GUINT | reservesize | ) |
| inline

Definition at line 129 of file gim_array.h.

## ◆ ~gim_array()

template<typename T>

gim_array< T >::~gim_array | ( |  | ) |
| inline

Definition at line 138 of file gim_array.h.

## Member Function Documentation

## ◆ at() [1/2]

template<typename T>

T & gim_array< T >::at | ( | GUINT | i | ) |
| inline

Definition at line 178 of file gim_array.h.

## ◆ at() [2/2]

template<typename T>

const T & gim_array< T >::at | ( | GUINT | i | ) | const
| inline

Definition at line 183 of file gim_array.h.

## ◆ back() [1/2]

template<typename T>

T & gim_array< T >::back | ( |  | ) |
| inline

Definition at line 198 of file gim_array.h.

## ◆ back() [2/2]

template<typename T>

const T & gim_array< T >::back | ( |  | ) | const
| inline

Definition at line 203 of file gim_array.h.

## ◆ clear()

template<typename T>

void gim_array< T >::clear | ( |  | ) |
| inline

Definition at line 110 of file gim_array.h.

## ◆ clear_memory()

template<typename T>

void gim_array< T >::clear_memory | ( |  | ) |
| inline

Definition at line 116 of file gim_array.h.

## ◆ clear_range()

template<typename T>

void gim_array< T >::clear_range | ( | GUINT | start_range | ) |
| inline

Definition at line 102 of file gim_array.h.

## ◆ destroyData()

template<typename T>

void gim_array< T >::destroyData | ( |  | ) |
| inline

protected operations

Definition at line 54 of file gim_array.h.

## ◆ erase()

template<typename T>

void gim_array< T >::erase | ( | GUINT | index | ) |
| inline

fast erase

Definition at line 247 of file gim_array.h.

## ◆ erase_sorted()

template<typename T>

void gim_array< T >::erase_sorted | ( | GUINT | index | ) |
| inline

Definition at line 265 of file gim_array.h.

## ◆ erase_sorted_mem()

template<typename T>

void gim_array< T >::erase_sorted_mem | ( | GUINT | index | ) |
| inline

Definition at line 256 of file gim_array.h.

## ◆ front() [1/2]

template<typename T>

T & gim_array< T >::front | ( |  | ) |
| inline

Definition at line 188 of file gim_array.h.

## ◆ front() [2/2]

template<typename T>

const T & gim_array< T >::front | ( |  | ) | const
| inline

Definition at line 193 of file gim_array.h.

## ◆ get_pointer_at() [1/2]

template<typename T>

T * gim_array< T >::get_pointer_at | ( | GUINT | i | ) |
| inline

Definition at line 168 of file gim_array.h.

## ◆ get_pointer_at() [2/2]

template<typename T>

const T * gim_array< T >::get_pointer_at | ( | GUINT | i | ) | const
| inline

Definition at line 173 of file gim_array.h.

## ◆ growingCheck()

template<typename T>

bool gim_array< T >::growingCheck | ( |  | ) |
| inline

Definition at line 82 of file gim_array.h.

## ◆ insert()

template<typename T>

void gim_array< T >::insert | ( | const T & | obj,
|  | GUINT | index )
| inline

Definition at line 281 of file gim_array.h.

## ◆ insert_mem()

template<typename T>

void gim_array< T >::insert_mem | ( | GUINT | index | ) |
| inline

Definition at line 271 of file gim_array.h.

## ◆ max_size()

template<typename T>

GUINT gim_array< T >::max_size | ( |  | ) | const
| inline

Definition at line 148 of file gim_array.h.

## ◆ operator[]() [1/2]

template<typename T>

T & gim_array< T >::operator[] | ( | size_t | i | ) |
| inline

Definition at line 153 of file gim_array.h.

## ◆ operator[]() [2/2]

template<typename T>

const T & gim_array< T >::operator[] | ( | size_t | i | ) | const
| inline

Definition at line 157 of file gim_array.h.

## ◆ pointer() [1/2]

template<typename T>

T * gim_array< T >::pointer | ( |  | ) |
| inline

Definition at line 162 of file gim_array.h.

## ◆ pointer() [2/2]

template<typename T>

const T * gim_array< T >::pointer | ( |  | ) | const
| inline

Definition at line 163 of file gim_array.h.

## ◆ pop_back()

template<typename T>

void gim_array< T >::pop_back | ( |  | ) |
| inline

Definition at line 234 of file gim_array.h.

## ◆ pop_back_mem()

template<typename T>

void gim_array< T >::pop_back_mem | ( |  | ) |
| inline

Simply decrease the m_size, doesn't call the deleted element destructor.

Definition at line 241 of file gim_array.h.

## ◆ push_back()

template<typename T>

void gim_array< T >::push_back | ( | const T & | obj | ) |
| inline

Definition at line 213 of file gim_array.h.

## ◆ push_back_mem()

template<typename T>

void gim_array< T >::push_back_mem | ( |  | ) |
| inline

Simply increase the m_size, doesn't call the new element constructor.

Definition at line 221 of file gim_array.h.

## ◆ push_back_memcpy()

template<typename T>

void gim_array< T >::push_back_memcpy | ( | const T & | obj | ) |
| inline

Definition at line 227 of file gim_array.h.

## ◆ refit()

template<typename T>

void gim_array< T >::refit | ( |  | ) |
| inline

Definition at line 312 of file gim_array.h.

## ◆ reserve()

template<typename T>

bool gim_array< T >::reserve | ( | GUINT | size | ) |
| inline

public operations

Definition at line 96 of file gim_array.h.

## ◆ resize()

template<typename T>

void gim_array< T >::resize | ( | GUINT | size,
|  | bool | call_constructor = true,
|  | const T & | fillData = T() )
| inline

Definition at line 287 of file gim_array.h.

## ◆ resizeData()

template<typename T>

bool gim_array< T >::resizeData | ( | GUINT | newsize | ) |
| inline

Definition at line 62 of file gim_array.h.

## ◆ size()

template<typename T>

GUINT gim_array< T >::size | ( |  | ) | const
| inline

Definition at line 143 of file gim_array.h.

## ◆ swap()

template<typename T>

void gim_array< T >::swap | ( | GUINT | i,
|  | GUINT | j )
| inline

Definition at line 208 of file gim_array.h.

## Member Data Documentation

## ◆ m_allocated_size

template<typename T>

GUINT gim_array< T >::m_allocated_size

Definition at line 49 of file gim_array.h.

## ◆ m_data

template<typename T>

T* gim_array< T >::m_data

properties

Definition at line 47 of file gim_array.h.

## ◆ m_size

template<typename T>

GUINT gim_array< T >::m_size

Definition at line 48 of file gim_array.h.

The documentation for this class was generated from the following file:

- gim_array.h